package com.fp.persistence.parmas.fun;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMCARGADETALLE*/
@Entity(name="TarmCargaDetalle")
@Table(name="TARMCARGADETALLE")
public class TarmCargaDetalle extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmCargaDetalle
*/
@Id
@Column(name="CCARGADETALLE" ,nullable=false, updatable=false)
private String pk;
@Column(name="CCARGA", nullable=false)

/**
* CODIGO DE CARGA
*/
private String ccarga;

@Column(name="CARMA", nullable=false)

/**
* CODIGO DE ARMA
*/
private String carma;

/**Contructor por defecto*/
public TarmCargaDetalle(){
}
/**Contructor de TarmCargaDetalle
@param pPk Clave Primaria del entity
@param pCcarga CODIGO DE CARGA
@param pCarma CODIGO DE ARMA
*/
public TarmCargaDetalle(String pPk,String pCcarga,String pCarma){
 this();
 pk=pPk;
 ccarga=pCcarga;
 carma=pCarma;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmCargaDetalle
*/
public static TarmCargaDetalle find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmCargaDetalle obj = pEntityManager.find(TarmCargaDetalle.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmCargaDetalle
@return El objeto que referencia a la Clave primaria de TarmCargaDetalle
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmCargaDetalle
@param pPk El objeto que referencia a la nueva Clave primaria de TarmCargaDetalle
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de ccarga
@return valor de ccarga*/
public String getCcarga(){
  return ccarga;
}
/**Fija el valor de ccarga
@param pCcarga nuevo Valor de ccarga*/
public void setCcarga(String pCcarga){
  ccarga=pCcarga;
}

/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmCargaDetalle))return false;
    TarmCargaDetalle that = (TarmCargaDetalle) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmCargaDetalle
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmCargaDetalle
*/
public Object createInstance(){
 TarmCargaDetalle instance=new TarmCargaDetalle();	
 return instance;
}
/**Clona la entidad TarmCargaDetalle
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmCargaDetalle p=(TarmCargaDetalle)this.clone();
  return p;
}
}
